#!/usr/bin/python2.7

import networkx as nx
import random as rand
import numpy as np
from string import ascii_uppercase as ucl
import matplotlib.pyplot as plt


if "initnumcells" not in locals():initnumcells=6
if "inverlambda" not in locals():inverlambda=1

#notes      
#
 
def makeemptycoalescentmodel(initnumcells,inverlambda):
	"""function that makes a general purpose empty coalescent model for cells that can be filled in with data of specific type, while building a newick string corresponding to that tree"""
	#get names off of the alphabet
	#print "inverlambda:",inverlambda
	if initnumcells<=26:
		initcellnames=list(ucl[:initnumcells])
	elif initnumcells<=26**2:
		initcellnames=[]
		maxcharpos1= initnumcells/26
		maxcharpos2= initnumcells%26
		for charpos1 in xrange(maxcharpos1):#correction for how xrange terminaes
			for charpos2 in xrange(26):
				initcellnames.append("%s%s"%(ucl[charpos1],ucl[charpos2]))
		for charpos2 in xrange(maxcharpos2):initcellnames.append("%s%s"%(ucl[maxcharpos1],ucl[charpos2]))
	elif initnumcells<=26**3:
		assert(False)# no reason to model so many cells

	setofcurrentcellstomerge=list(initcellnames)# list of cells that will be merged inot an ancestor
	#dicfornewick={}
	evotree=nx.Graph()#graph to hold the evoluntary tree of cells as it forms
	evotree.add_nodes_from(initcellnames,celldata=None)
	while(nx.number_connected_components(evotree)>1):
		nodestomerge=rand.sample(setofcurrentcellstomerge,2)
		newname=[oldnodename.split("|") for oldnodename in nodestomerge]
		newname=newname[0]+newname[1]
		newname=sorted(newname)
		newname="|".join(newname)
		print nodestomerge, newname
		evotree.add_node(newname,celldata=None)
		setofcurrentcellstomerge.remove(nodestomerge[0])
		setofcurrentcellstomerge.remove(nodestomerge[1])
		setofcurrentcellstomerge.append(newname)
		#if (nodestomerge[0] not in dicfornewick) and (nodestomerge[1] not in dicfornewick):
		#	dicfornewick[newname]="(%s,%s)"%(nodestomerge[0],nodestomerge[1])
		#elif (nodestomerge[0] not in dicfornewick):
		#	dicfornewick[newname]="(%s,%s)"%(nodestomerge[0],dicfornewick[nodestomerge[1]])
		#elif (nodestomerge[1] not in dicfornewick):
		#	dicfornewick[newname]="(%s,%s)"%(dicfornewick[nodestomerge[0]],nodestomerge[1])
		#else:
		#	dicfornewick[newname]="(%s,%s)"%(dicfornewick[nodestomerge[0]],dicfornewick[nodestomerge[1]])
		evotree.add_edges_from([(nodestomerge[0],newname),(nodestomerge[1],newname)],numberofdivisionsbetween=rand.expovariate(inverlambda))#maybe round to get integer number of divisons
	return evotree#,(dicfornewick[newname])+";"#last entryis final string

def makebalancedbinaryemptycoalescentmodel(initnumcells,inverlambda):
	"""function that makes a general purpose empty coalescent model for cells that can be filled in with data of specific type, while building a newick string corresponding to that tree"""
	#get names off of the alphabet
	print "balanced binary tree to be made"
	if initnumcells<=26:
		initcellnames=list(ucl[:initnumcells])
	elif initnumcells<=26**2:
		initcellnames=[]
		maxcharpos1= initnumcells/26
		maxcharpos2= initnumcells%26
		for charpos1 in xrange(maxcharpos1):#correction for how xrange terminaes
			for charpos2 in xrange(26):
				initcellnames.append("%s%s"%(ucl[charpos1],ucl[charpos2]))
		for charpos2 in xrange(maxcharpos2):initcellnames.append("%s%s"%(ucl[maxcharpos1],ucl[charpos2]))
	elif initnumcells<=26**3:
		assert(False)# no reason to model so many cells

	currentlayer=list(initcellnames)# list of cells that will be merged inot an ancestor
	nextlayer=[]
	#dicfornewick={}
	evotree=nx.Graph()#graph to hold the evoluntary tree of cells as it forms
	evotree.add_nodes_from(initcellnames,celldata=None)
	#currentlayer=evotree.nodes()
	while(nx.number_connected_components(evotree)>1):
		while(len(currentlayer)>1):
			nodestomerge=rand.sample(currentlayer,2)
			newname=[oldnodename.split("|") for oldnodename in nodestomerge]
			newname=newname[0]+newname[1]
			newname=sorted(newname)
			newname="|".join(newname)
			print nodestomerge, newname
			evotree.add_node(newname,celldata=None)
			currentlayer.remove(nodestomerge[0])
			currentlayer.remove(nodestomerge[1])
			nextlayer.append(newname)
			#if (nodestomerge[0] not in dicfornewick) and (nodestomerge[1] not in dicfornewick):
			#	dicfornewick[newname]="(%s,%s)"%(nodestomerge[0],nodestomerge[1])
			#elif (nodestomerge[0] not in dicfornewick):
			#	dicfornewick[newname]="(%s,%s)"%(nodestomerge[0],dicfornewick[nodestomerge[1]])
			#elif (nodestomerge[1] not in dicfornewick):
			#	dicfornewick[newname]="(%s,%s)"%(dicfornewick[nodestomerge[0]],nodestomerge[1])
			#else:
			#	dicfornewick[newname]="(%s,%s)"%(dicfornewick[nodestomerge[0]],dicfornewick[nodestomerge[1]])
			evotree.add_edges_from([(nodestomerge[0],newname),(nodestomerge[1],newname)],numberofdivisionsbetween=rand.expovariate(inverlambda))#maybe round to get integer number of divisons
			if len(currentlayer)==1:nextlayer.append(currentlayer[0])
		currentlayer,nextlayer=nextlayer,[]
	return evotree#,(dicfornewick[newname])+";"#last entryis final string


def roughimageofgraphforcellsms(cellevotree,outputstring="%s",formattuple="(node)"):
	""" function that draws a fast and simple graph of the tree entered with nodes labeled"""
	labeldic={}
	for node in cellevotree.nodes():labeldic[node]=outputstring%eval(formattuple)
	nx.draw_networkx(cellevotree,labels=labeldic)
	plt.draw()
	plt.show()

def findlongestnodename(evotree):
	"""function that sorts a list of node names by the length of the name and returns longest name"""
	def lencmp(a,b):
		if len(a)<len(b):return -1
		if len(a)>len(b):return 1
		else:return 0
	return sorted(evotree.nodes(),cmp=lencmp,reverse=True)[0]

def finddescendants(evotree,LCA):
	"""function that use built in breadth first search algorithm in networkx to figure out the descendants of each cell in the tree"""
	return nx.algorithms.traversal.breadth_first_search.bfs_successors(evotree,LCA)

def makedicofnodedata(evotree):
	""" function that makes a dict where the name of a node points to hidden data about the node for easy access to that data"""
	return dict(evotree.nodes(data=True))

def updatecelldata(dicofnodedata,node,newcelldata):
	""" function that in a safe manner access and changes hidden data for a node/cell"""
	assert(node in dicofnodedata)
	dicofnodedata[node]["celldata"]=newcelldata

def accesscelldata(dicofnodedata,node):
	""" function that in a safe manner access hidden data for a node/cell"""
	assert(node in dicofnodedata)
	return dicofnodedata[node]["celldata"]


def findnewickrepresentationofatreewrapper(tree):
	""" function that takes in a networkx tree of the coalescent tree model and returns a newick string representation of tree using the recursive findnewickrepresentationofasubtree """
	if not nx.is_tree(tree):return None
	LCA=findlongestnodename(tree)
	dicofsedges=nx.dfs_successors(tree,LCA)
	listofsuccessorstrings=[]
	for successor in dicofsedges[LCA]:
		listofsuccessorstrings.append(findnewickrepresentationofasubtree(tree,successor,LCA))                
	return "("+ ",".join(listofsuccessorstrings) +");"

def findnewickrepresentationofasubtree(tree,currentroot,parentofroot):
        """ function that takes a network x subtree of the coalescent tree model and return a newick string of a subtree """
        if len(nx.neighbors(tree,currentroot))==1:return currentroot
        subtreesuccessors=nx.dfs_successors(tree,currentroot)
        if parentofroot in subtreesuccessors:subtreesuccessors.pop(parentofroot)
        for node in subtreesuccessors:
                if parentofroot in subtreesuccessors[node]:subtreesuccessors[node].remove(parentofroot)
        listofsuccessorstrings=[]
        for successor in subtreesuccessors[currentroot]:
                listofsuccessorstrings.append(findnewickrepresentationofasubtree(tree,successor,currentroot))                
        return "("+ ",".join(listofsuccessorstrings) +")"
