#!/usr/bin/python2.7

import networkx as nx
import random as rand
import numpy as np

#notes
"""def mrun(num):
lst=[]
for i in xrange(num):
	print m.MSL,
	a=m.mutate(mode="lld")
	print a
	lst.append(a[0])
	lst.append(a[1])
return lst"""
"""m=Microsatelite(5,addone)"""
"""m=Microsatelite(5,simpleslippageandpointmutation,"lldp-slp")"""
"""c=Cell(3,True,5,addone,"",15,.01,.957, False, False)"""
"""c=Cell(3,True,5,simpleslippageandpointmutation,"lldp-slp",15,.01,.957, False, False)"""
"""
mslenl=[3,4,5]
msmodelsl=[simpleslippageandpointmutation,simpleslippageandpointmutation,addone]
MSrequiredparam=["lldp-slp","lldp-slp",""]
msupperlimitl=[15,15,15]
mslldp=[0.01]*3
msslippagelikelihoodprobability=[.957]*3
ce=Cell(3,False,mslenl,msmodelsl,MSrequiredparam,msupperlimitl,mslldp,msslippagelikelihoodprobability, False, False)
"""
#

def addone(MSL):
	"""basic dummy function to mutate a MSL length"""
	return [MSL+1]
    
def simplestepwise(MSL):
	"""SMM,basic MSL mutation model, simpliest, that increases or decreases, at random, the length of a MSL """
	"from paper"
	if(MSL<0):assert(False)
	if(MSL==0):newMSL=0
	else:newMSL=MSL+(rand.sample([-1,1],1))[0]
	return [newMSL]

def simplestepwisewithuppercutoff(MSL,upperlimit=10**10):
	"""improved MSL mutation model, that increases or decreases, at random, the length of a MSL, with the likelihood of increase or decreasing changing linearly depending on how close the MSL is to the upperlimit """
	"from paper"
	percentlikelytodecrease=float(MSL)/upperlimit#old-percentlikelytodecrease=int(MSL*100.0/upperlimit)#print len([-1]*percentlikelytodecrease+[1]*(100-percentlikelytodecrease)), ([-1]*percentlikelytodecrease+[1]*(100-percentlikelytodecrease)).count(-1), ([-1]*percentlikelytodecrease+[1]*(100-percentlikelytodecrease)).count(1)
	if(MSL<0):assert(False)
	if(MSL==0):newMSL=0#else:newMSL=MSL+(rand.sample(([-1]*percentlikelytodecrease+[1]*(100-percentlikelytodecrease)),1))[0]
	else:
		if (rand.random()<percentlikelytodecrease):newMSL=MSL-1
		else: newMSL=MSL+1
	return [newMSL]
	
def simpleslippageandpointmutation(MSL,lldp=.01,slippagelikelihoodprobability=.957,mode=None):
	"""improved MSL mutation model, that incorporates the possibility of MSL slippage, point mutation to break MSL length and a transition from MSL of 1 to 2 """
	"from paper"
	assert(type(MSL).__name__=="int")
	slippagemodelmutation=simplestepwise
	if mode=="zero":MSL=0
	if mode=="lld":MSL=1
	if mode=="slip":slippagelikelihoodprobability=10
	if mode=="split":slippagelikelihoodprobability=0
	if(MSL<0):assert(False)
	if (MSL==0):
		mode="stuck at zero"
		newMSL=0
	elif (MSL==1): 
		mode="low likelihood duplication possible"
		newMSL=lowlikelihoodduplication(MSL,lldp)
	else:
		if (rand.random()<slippagelikelihoodprobability):
			mode="slippage model used"
			newMSL=(slippagemodelmutation(MSL))[0]# default value of .957 for slippagelikelihoodprobability correpsonds to a=1*10^-8, b=2.2*10^-6 , b/a=22, b/(b+a)=.957
		else:
			mode="splitting by point mutation"
			newMSL=pointmutationsplittingmutation(MSL)# parameter a/(b/a) =1-slippagelikelihoodprobability
	return [newMSL,mode]
	
#######subfunctions for simpleslippageandpointmutation##################
def lowlikelihoodduplication(MSL,lldp):
	""" function that wit low likelihood will duplicate the MSL or with low likelihood cuase a slippage event to happen""" 
	if (rand.random()<lldp):return 2*MSL
	else:
		#if (rand.random()<lldp):MSL=(slippagemodelmutation(MSL))[0]#its possible a slippage even ahppens instead
		return MSL
	
def pointmutationsplittingmutation(MSL):
	""" function that will take a MSL of length x and at random decrease it between x-1 and 1 to simulate a point mutation splitting a MSL, and since only the first section is counted this causes the MSL to shrink quickly"""
	return MSL - rand.randint(1,MSL-1)#MSL length decreases from MSL to anywhere between 1 and MSL-1 (equivalent to MSL-[1,MSL-1])
	

################################################################## 


class Microsatelite(object):
	"""class that holds a model of a microsatelite"""
	def init_checks(self):
		assert(type(self.MSL).__name__=="int")
		assert(self.MSL>=0)
		if "uplim" in self.param:assert(type(self.upperlimit).__name__=="int")
		if self.mutmodel.__name__=="simplestepwisewithuppercutoff":assert("uplim" in self.param)
		if self.mutmodel.__name__=="simpleslippageandpointmutation":assert("lldp-slp" in self.param)
		#print "no problem with init"
	
	def __init__(self,MSL,mutationmodel,requiredparam="",upperlimit="doubleMSL",lldp=.01,slippagelikelihoodprobability=.957):
		#MSL is the Microsatelite length
		assert(type(MSL).__name__=="int")
		self.MSL=MSL
		self.mutmodel=mutationmodel
		if (upperlimit=="doubleMSL"):self.upperlimit=2*self.MSL
		else:self.upperlimit=upperlimit
		self.lldp=lldp
		self.slippagelikelihoodprobability=slippagelikelihoodprobability
		#param are "uplim","lldp-slp"
		self.param=requiredparam
		self.init_checks()

	def __str__(self):
		return "A Microsatelite with a length of %d that use a mutation model with the name of %s"%(self.MSL,self.mutmodel.__name__)
	
	def copy(self):
		return Microsatelite(self.MSL,self.mutmodel,self.param,self.upperlimit,self.lldp,self.slippagelikelihoodprobability)
	
	def mutate(self,mode=None):
		#make tuple for input
		inputlist=[self.MSL]
		if ("uplim" in self.param):inputlist=inputlist+[self.upperlimit]#print self.param, tuple(inputlist)
		if ("lldp-slp" in self.param):inputlist=inputlist+[self.lldp,self.slippagelikelihoodprobability]#print self.param, tuple(inputlist)
		if mode!=None:inputlist=inputlist+[mode]
		data=self.mutmodel(*tuple(inputlist)) #print tuple(inputlist)
		self.MSL=data[0]
		return data

class Cell(object):
	"""class that holds a model of a cell as a collection of microsatelites"""
	def init_checks(self):
		assert(type(self.initdata["identical"]).__name__=="bool")
		assert(type(self.msnumber).__name__=="int")
		assert(type(self.initdata["clone"]).__name__=="bool")
		assert(hasattr(self.MSnames,"__iter__"))
		for item in self.MSnames: assert(type(item).__name__=="str")
		assert(self.msnumber==len(self.MSnames))
		if self.initdata["identical"]:
			assert(not(hasattr(self.initdata["mslen"],"__iter__")))
			assert(type(self.initdata["mslen"]).__name__=="int")
			assert(self.initdata["mslen"]>=0)
			assert(type(self.initdata["msmodels"]).__name__=="function")
			assert(type(self.initdata["msrequiredparam"]).__name__=="str")
			assert(self.initdata["msupperlimit"]>=self.initdata["mslen"])
			assert(type(self.initdata["mslldp"]).__name__=="float")
			assert(self.initdata["mslldp"]>=0.0 and self.initdata["mslldp"]<=1.0)
			assert(type(self.initdata["msslippagelikelihoodprobability"]).__name__=="float")
			assert(self.initdata["msslippagelikelihoodprobability"]>=0.0 and self.initdata["msslippagelikelihoodprobability"]<=1.0)
		else:
			assert(hasattr(self.initdata["mslen"],"__iter__"))
			assert(len(self.initdata["mslen"])==self.msnumber)
			for item in self.initdata["mslen"]:
				assert(type(item).__name__=="int")
				assert(item>=0)
			assert(hasattr(self.initdata["msmodels"],"__iter__"))
			assert(len(self.initdata["mslen"])==len(self.initdata["msmodels"]))
			for item in self.initdata["msmodels"]: assert(type(item).__name__=="function")
			assert(hasattr(self.initdata["msrequiredparam"],"__iter__"))
			assert(len(self.initdata["msrequiredparam"])==len(self.initdata["msmodels"]))
			for item in self.initdata["msrequiredparam"]: assert(type(item).__name__=="str")
			assert(hasattr(self.initdata["msupperlimit"],"__iter__"))
			assert(len(self.initdata["msrequiredparam"])==len(self.initdata["msupperlimit"]))
			for pos in xrange(len(self.initdata["msupperlimit"])): 
				assert(type(self.initdata["msupperlimit"][pos]).__name__=="int")
				assert(self.initdata["msupperlimit"][pos]>=self.initdata["mslen"][pos])
			assert(hasattr(self.initdata["mslldp"],"__iter__"))
			assert(len(self.initdata["mslldp"])==len(self.initdata["msupperlimit"]))
			for item in self.initdata["mslldp"]:
				assert(type(item).__name__=="float")
				assert(item>=0.0 and item<=1.0)
			assert(hasattr(self.initdata["msslippagelikelihoodprobability"],"__iter__"))
			assert(len(self.initdata["mslldp"])==len(self.initdata["msslippagelikelihoodprobability"]))
			for item in self.initdata["msslippagelikelihoodprobability"]:
				assert(type(item).__name__=="float")
				assert(item>=0.0 and item<=1.0)
		#print "no problem with init for cell"
	
	def __init__(self,MSnumber,identical=True,mslen=0,MSmodels=0,MSrequiredparam=0,MSupperlimit=0,MSlldp=0,MSslippagelikelihoodprobability=0,clone=False,specifynames=False):
		#default values corresponds to values needed for an "empty" cell to be produced
		# to copy only "empty" cell, only msnumber and clone (as True) needs to be specified
		self.msnumber=MSnumber# variable that holds how many MS are present in cell
		if not clone: # if a cell is being cloned no need for all this data since microsatelites are copied directly, makes an "empty" cell for microsatelites to be copied into
			self.initdata={}
			self.initdata["identical"]=identical# variable that decides whether or not all MS are initialized as identical
			self.initdata["mslen"]=mslen#variable if identical or list of variables if not identical, that determines number or repeats in each MS
			self.initdata["msmodels"]=MSmodels#variable if identical or list of variables if not identical, that determines mutation model in each MS
			self.initdata["msrequiredparam"]=MSrequiredparam#variable if identical or list of variables if not identical, that determines required parameters in each MS
			self.initdata["msupperlimit"]=MSupperlimit#variable if identical or list of variables if not identical, that determines maximum number of repeats in each MS
			self.initdata["mslldp"]=MSlldp#variable if identical or list of variables if not identical, that determines low likelihood duplication if repeat number reaches one in each MS
			self.initdata["msslippagelikelihoodprobability"]=MSslippagelikelihoodprobability #variable if identical or list of variables if not identical, that determines probability that slippage mutation occurs as opposed to split mutation in each MS
			self.initdata["clone"]=clone# variable that decides whether or not all MS are initialized as identical
			if (type(specifynames).__name__!="bool" and len(specifynames)==self.msnumber):self.MSnames=specifynames
			else:self.MSnames=["M%d"%(pos) for pos in xrange(self.msnumber)]#format for uniform length	
			self.init_checks()
		self.MS=[]
		if not clone:# this is to avoid extra work when cell is cloned because each microsatelite is individually copied
			if self.initdata["identical"]:
				for marker in xrange(self.msnumber):
					self.MS.append(Microsatelite(self.initdata["mslen"],self.initdata["msmodels"],
									self.initdata["msrequiredparam"],self.initdata["msupperlimit"],
									self.initdata["mslldp"],self.initdata["msslippagelikelihoodprobability"]))
				self.initdata["mslen"]=[mslen]*self.msnumber
				self.initdata["msmodels"]=[MSmodels]*self.msnumber
				self.initdata["msrequiredparam"]=[MSrequiredparam]*self.msnumber
				self.initdata["msupperlimit"]=[MSupperlimit]*self.msnumber
				self.initdata["mslldp"]=[MSlldp]*self.msnumber
				self.initdata["msslippagelikelihoodprobability"]=[MSslippagelikelihoodprobability]*self.msnumber
			else:
				for m in xrange(self.msnumber):# m is marker
					self.MS.append(Microsatelite(self.initdata["mslen"][m],self.initdata["msmodels"][m],
									self.initdata["msrequiredparam"][m],self.initdata["msupperlimit"][m],
									self.initdata["mslldp"][m],self.initdata["msslippagelikelihoodprobability"][m]))

		
	
	def __str__(self):
		averagelenofMS=float(sum(ms.MSL for ms in self.MS))/self.msnumber
		string="A Cell with %d Microsatelites with an average length of %f\n"%(self.msnumber,averagelenofMS)
		string+="Individual details for each microsatelite is below: \n"
		for pos in xrange(self.msnumber):string+="%s microsatelite has a MSL of %d and has a mutation model of %s\n"%(self.MSnames[pos],(self.MS[pos]).MSL,(self.MS[pos]).mutmodel.__name__)
		return string
		
	def len_str(self):
		"""crude function to get only a print out of the lengths"""
		string= "only the MSlens: \n"
		for pos in xrange(self.msnumber):string+="%d\n"%((self.MS[pos]).MSL)
		return string
	
	def copy(self):
		newcell=Cell(self.msnumber,clone=True)
		for pos in xrange(self.msnumber):newcell.MS.append(self.MS[pos].copy())
		newcell.MSnames=list(self.MSnames)
		return newcell
	
	def mutate(self,pos=None):
		if type(pos).__name__=="NoneType":
			ranpos=rand.randint(0,(self.msnumber-1))
		else:
			assert(type(pos).__name__=="int")
			ranpos=pos
		oldMSL=self.MS[ranpos].MSL
		self.MS[ranpos].mutate()
		return "The MS at pos: %d has mutated from %d to %d\n"%(ranpos, oldMSL, self.MS[ranpos].MSL)
			
