#from infoanalysis import *
import networkx as nx
#import os

nulllinetoinitiatenode='{|{|{ {|{|{{|{|{  {|{|{{|{|{  '


class node(object):
    def __init__(self,line,parent):#,#data):
        data=line.split()
        self.number=data[0]
        data1=data[1].split('|')
        self.count=data1[1]
        data1=data1[0]
        data1=data1.split('{')
        self.probenum=str(data1[1])
        self.children=[]
        self.chnames=[]
        self.eweights=[]
        self.parent=parent
        self.pname=None

        #already=False 
        #for chil in parent.children
        #	if (checkequal(chil,self)):already=True
        if parent!=None	:
            parent.children=parent.children + [self]
            self.pname=parent.probenum
            parent.chnames=parent.chnames+[self.probenum]
        #self.leftchild=None
        #self.rightchild=None
        #self.leftvalue=None
        #self.rightvalue=None

    def addparent(self,parent,eweight):
        self.parent=parent
        #already=False 
        #for chil in parent.children
        #	if (checkequal(chil,self)):already=True
        if parent!=None	:
            parent.children=parent.children + [self]
            self.pname=parent.probenum
            parent.chnames=parent.chnames+[self.probenum]
            self.eweights=self.eweights+[eweight]

    def addchild(self,child):
        self.children=self.children+[child]
        self.chnames=self.chnames+[child.probenum]
        child.parent=self
        #already=False 
        #for chil in parent.children
        #	if (checkequal(chil,self)):already=True
        #if child!=None	:
        #    self.children=parent.children + [self]

    def copy(self):
        newnode=node('{|{|{ {|{|{{|{|{  {|{|{{|{|{  ',None)
        newnode.number=self.number
        newnode.count=self.count
        #print self.count, newnode.count
        newnode.probenum=self.probenum
        newnode.children=[]
        newnode.chnames=[]
        newnode.eweights=[]
        newnode.parent=None
        #print vars(newnode)
        return newnode

def checkparentchildrelation(cnode):
    #prints info about node in a ncely formatedway
    print 'pname: ', cnode.pname
    for ch in cnode.chnames:
        print ch, ' is a child'
        
def printallnodes(checkparentchildrelation,treed):
    #prints a tree in a nicely formatted way
    for cnode in treed.dic:
        print "adjacent nodes:", cnode
        checkparentchildrelation(treed.dic[cnode])
        print
            
		
def checkequalinsametree(node1,node2):
	return (node1.number==node2.number) and (node1.probenum==node2.probenum)
	
def checkequal(node1,node2):
	return (node1.probenum==node2.probenum)
	

class treedata(object):
    def __init__(self,tree=nx.Graph()):
        self.dic={}
        self.tree=tree
        

def writetodotdot(treedata,filename):
    """a function that takes a tree in the format of treedata and writes it to a file in .dot format as a un-directed graph compatible with graphviz and xdot """
    newf=open(filename,'w')
    # write first few lines in .dot file
    newf.write('graph tree {\n')
    newf.write('	node [shape=record];\n')
    counter=0
    info1={}
    for item in treedata.dic:
        #for each node write its entry in the file and assign a number for later to making writing edges easy
        currentitem= treedata.dic[item]
        newf.write('	%d [label="{%s|%s\n'%(counter,currentitem.probenum,currentitem.count))
        info1[currentitem.probenum]=counter
        counter+=1
    for item in treedata.dic:
        # for each node find its node in the dic
        currentitem= treedata.dic[item]
        for pos in info1:
            if pos==currentitem.probenum:
                currentitemnumber= info1[pos] 
                break
        #and then for each of its children find the the child nodes and write the edge in the file
        for child in currentitem.chnames:
            for pos in info1:
                if pos==child:
                    currentchildnumber=info1[pos]
                    #print treedata.tree[currentitem.probenum][child],treedata.tree[currentitem.probenum][child]['weight']
                    newf.write('	%d -- %d [color=green,label="%1.5f"];\n'%(currentitemnumber,currentchildnumber,treedata.tree[currentitem.probenum][child]['weight']))
    #add last line and then finish
    newf.write('}\n')
    newf.close()
    print

#%% 

def readdotdot(filename,node=node):
    """a function that takes a filename for a digraph written in .dot format and reads in the file and outputs a tree in treedata format """
    treed=treedata()
    #read in data from file line by line
    F=open(filename)
    line=(F.readline()).lstrip()
    while (len(line)>0):
        #if first object is not a numer sonething is wrog
        if line[0].isdigit():
            if (line.split())[1]=='->':
                #if '->' in line this line encodes an edges so process line as edge and write it in treedata
                parent=(line.split())[0]
                child=(line.split())[2]
                #find nodes and added weighted edges between nodes
                eweight=float((((line.split())[3]).split('"'))[1])
                for node in treed.dic:
                    if (treed.dic[node].number==parent):pnode=treed.dic[node]
                    if (treed.dic[node].number==child):cnode=treed.dic[node]
                cnode.addparent(pnode,float(eweight))
                treed.tree.add_weighted_edges_from([(pnode.probenum,cnode.probenum,eweight)])
            else:
                #else it is just a node assignment, make a new node add to dic and add noew node in networkx graph
                newnode=node(line,None)
                #newnode.probenum=str(newnode.probenum)
                treed.dic[newnode.probenum]=newnode
                treed.tree.add_node(newnode.probenum)
        #read next line and if it is empty finish up
        line=(F.readline()).lstrip()
    F.close()

    return treed
    
def parseprobenumstr(st):
    """Function takes in a line of features and counts from a .dot formatted file and returnd a dictionary with keys being feature names and values being counts """
    string=st.split('\\n')
    ps={}
    for probest in string:
        (pname,count)=probest.split('(')
        count=int(count[:-1])
        ps[pname]=count
    return ps
    
def comparedics(d1,d2,ignore=["CEP1"]):
    """Function takes two dictionaries and checks if they share the same keys and have the same values for the same keys, while ignoring certain keys,
    useful to compare 2 dicitionaries which hold sets of features and their counts"""
    #ignore"CEP1", dummy probe
    for i in d1:
        if i in ignore:continue
        if i not in d2:return False
    for i in d2:
        if i in ignore:continue
        if i not in d1:return False
    for i in d1:
        if i in ignore:continue
        if d1[i]!=d2[i]:return False
    return True
    
def reroottreedata(treed,directededges):   
    """Function that takes a treedata object and makes a modified copy that has the starting node in the dic(which is has a node that has no parents and is the starting point) changed to another node """
    #copy treedata but with only the networkx undirected graph
    rerootedtd=treedata(treed.tree.copy())
    # then copy nodes in the dictionary with without edges
    for oldn in treed.dic:
        #print oldn, treed.dic[oldn]
        rerootedtd.dic[oldn]=treed.dic[oldn].copy()
    #print rerootedtd.dic.keys()
    #print rerootedtd.tree.nodes()
    #print treed.dic.keys()
    #print treed.tree.nodes()
    # add in edges using the directed edges dicitionary to add the edges with the correct directionality
    for startn in directededges:
        for endn in directededges[startn]:
            #print startn, endn
            sn=rerootedtd.dic[startn]
            en=rerootedtd.dic[endn]
            en.addparent(sn,rerootedtd.tree[startn][endn])
    return rerootedtd

def makenxrenamedic(nxgraph):
    renamedic={}
    for node in nxgraph.nodes():renamedic[node]=node
    return renamedic
    
def makeblanknode(number,numtypes,celltype,nulllinetoinitiatenode):
    #nulllinetoinitiatenode='{|{|{ {|{|{{|{|{  {|{|{{|{|{  '
    newnode=node(nulllinetoinitiatenode,None)
    newnode.number=number
    newnode.count=str(1/numtypes)+"}\"];"
    newnode.probenum=celltype
    newnode.children=[]
    newnode.chnames=[]
    newnode.eweights=[]
    newnode.parent=None
    return newnode